#debuginfo not supported with Go
%global debug_package %{nil}
# modifying the Go binaries breaks the DWARF debugging
%global __os_install_post %{_rpmconfigdir}/brp-compress

%global gopath      %{_datadir}/gocode
%global import_path github.com/openshift/origin
%global sdn_import_path github.com/openshift/openshift-sdn
# The following should only be used for cleanup of sdn-ovs upgrades
%global kube_plugin_path /usr/libexec/kubernetes/kubelet-plugins/net/exec/redhat~openshift-ovs-subnet

# docker_version is the version of docker requires by packages
%global docker_version 1.8.2
# tuned_version is the version of tuned requires by packages
%global tuned_version  2.3
# openvswitch_version is the version of openvswitch requires by packages
%global openvswitch_version 2.3.1
# this is the version we obsolete up to. The packaging changed for Origin
# 1.0.6 and OSE 3.1 such that 'openshift' package names were no longer used.
%global package_refector_version 3.0.2.900
# %commit and %ldflags are intended to be set by tito custom builders provided
# in the .tito/lib directory. The values in this spec file will not be kept up to date.
%{!?commit:
%global commit 3941102b8a022b5f2d9ec2c94d1f13d519fa9c31
}
%global shortcommit %(c=%{commit}; echo ${c:0:7})
# ldflags from hack/common.sh os::build:ldflags
%{!?ldflags:
%global ldflags -X github.com/openshift/origin/pkg/version.majorFromGit 1 -X github.com/openshift/origin/pkg/version.minorFromGit 1+ -X github.com/openshift/origin/pkg/version.versionFromGit v1.1.4 -X github.com/openshift/origin/pkg/version.commitFromGit %{shortcommit} -X k8s.io/kubernetes/pkg/version.gitCommit 91d3e75 -X k8s.io/kubernetes/pkg/version.gitVersion v1.2.0-origin-41-g91d3e75
}

%if 0%{?fedora} || 0%{?epel}
%global make_redistributable 0
%else
%global make_redistributable 1
%endif

%if "%{dist}" == ".el7aos"
%global package_name atomic-openshift
%global product_name Atomic OpenShift
%else
%global package_name origin
%global product_name Origin
%endif

Name:           %{package_name}
Version:        1.1.4
Release:        1.osbs%{?dist}
Summary:        Open Source Container Management by Red Hat
License:        ASL 2.0
URL:            https://%{import_path}
ExclusiveArch:  x86_64
Source0:        https://%{import_path}/archive/%{commit}/%{name}-%{version}.tar.gz
BuildRequires:  systemd
BuildRequires:  golang >= 1.4
Requires:       %{name}-clients = %{version}-%{release}
Requires:       iptables
Obsoletes:      openshift < %{package_refector_version}

#
# The following Bundled Provides entries are populated automatically by the
# OpenShift Origin tito custom builder found here:
#   https://github.com/openshift/origin/blob/master/.tito/lib/origin/builder/
#
# These are defined as per:
# https://fedoraproject.org/wiki/Packaging:Guidelines#Bundling_and_Duplication_of_system_libraries
#
### AUTO-BUNDLED-GEN-ENTRY-POINT

Patch0:         0001-remove-annotation-size-limit.patch

%description
Origin is a distribution of Kubernetes optimized for enterprise application
development and deployment, used by OpenShift 3 and Atomic Enterprise. Origin
adds developer and operational centric tools on top of Kubernetes to enable
rapid application development, easy deployment and scaling, and long-term
lifecycle maintenance for small and large teams and applications.

%package master
Summary:        %{product_name} Master
Requires:       %{name} = %{version}-%{release}
Requires(post):   systemd
Requires(preun):  systemd
Requires(postun): systemd
Obsoletes:      openshift-master < %{package_refector_version}

%description master
%{summary}

%package tests
Summary: %{product_name} Test Suite
Requires:       %{name} = %{version}-%{release}

%description tests
%{summary}

%package node
Summary:        %{product_name} Node
Requires:       %{name} = %{version}-%{release}
Requires:       docker-io >= %{docker_version}
Requires:       tuned-profiles-%{name}-node = %{version}-%{release}
Requires:       util-linux
Requires:       socat
Requires:       nfs-utils
Requires:       ethtool
Requires(post):   systemd
Requires(preun):  systemd
Requires(postun): systemd
Obsoletes:      openshift-node < %{package_refector_version}

%description node
%{summary}

%package -n tuned-profiles-%{name}-node
Summary:        Tuned profiles for %{product_name} Node hosts
Requires:       tuned >= %{tuned_version}
Obsoletes:      tuned-profiles-openshift-node < %{package_refector_version}

%description -n tuned-profiles-%{name}-node
%{summary}

%package clients
Summary:        %{product_name} Client binaries for Linux
Obsoletes:      openshift-clients < %{package_refector_version}
Requires:       git

%description clients
%{summary}

%if 0%{?make_redistributable}
%package clients-redistributable
Summary:        %{product_name} Client binaries for Linux, Mac OSX, and Windows
BuildRequires:  golang-pkg-darwin-amd64
BuildRequires:  golang-pkg-windows-386
Obsoletes:      openshift-clients-redistributable < %{package_refector_version}

%description clients-redistributable
%{summary}
%endif

%package dockerregistry
Summary:        Docker Registry v2 for %{product_name}
Requires:       %{name} = %{version}-%{release}

%description dockerregistry
%{summary}

%package pod
Summary:        %{product_name} Pod

%description pod
%{summary}

%package recycle
Summary:        %{product_name} Recycler
Requires:       %{name} = %{version}-%{release}

%description recycle
%{summary}

%package sdn-ovs
Summary:          %{product_name} SDN Plugin for Open vSwitch
Requires:         openvswitch >= %{openvswitch_version}
Requires:         %{name}-node = %{version}-%{release}
Requires:         bridge-utils
Requires:         ethtool
Requires:         procps-ng
Requires:         iproute
Obsoletes:        openshift-sdn-ovs < %{package_refector_version}

%description sdn-ovs
%{summary}

%prep
%setup -qn origin-%{commit}
%patch0 -p1

%build

# Don't judge me for this ... it's so bad.
mkdir _build

# Horrid hack because golang loves to just bundle everything
pushd _build
    mkdir -p src/github.com/openshift
    ln -s $(dirs +1 -l) src/%{import_path}
popd


# Gaming the GOPATH to include the third party bundled libs at build
# time.
mkdir _thirdpartyhacks
pushd _thirdpartyhacks
    ln -s \
        $(dirs +1 -l)/Godeps/_workspace/src/ \
            src
popd
export GOPATH=$(pwd)/_build:$(pwd)/_thirdpartyhacks:%{buildroot}%{gopath}:%{gopath}
# Build all linux components we care about
for cmd in oc openshift dockerregistry recycle
do
        go install -ldflags "%{ldflags}" %{import_path}/cmd/${cmd}
done
go test -c -o _build/bin/extended.test -ldflags "%{ldflags}" %{import_path}/test/extended

%if 0%{?make_redistributable}
# Build clients for other platforms
GOOS=windows GOARCH=386 go install -ldflags "%{ldflags}" %{import_path}/cmd/oc
GOOS=darwin GOARCH=amd64 go install -ldflags "%{ldflags}" %{import_path}/cmd/oc
%endif

#Build our pod
pushd images/pod/
    go build -ldflags "%{ldflags}" pod.go
popd

%install

install -d %{buildroot}%{_bindir}

# Install linux components
for bin in oc openshift dockerregistry recycle
do
  echo "+++ INSTALLING ${bin}"
  install -p -m 755 _build/bin/${bin} %{buildroot}%{_bindir}/${bin}
done
install -d %{buildroot}%{_libexecdir}/%{name}
install -p -m 755 _build/bin/extended.test %{buildroot}%{_libexecdir}/%{name}/

%if 0%{?make_redistributable}
# Install client executable for windows and mac
install -d %{buildroot}%{_datadir}/%{name}/{linux,macosx,windows}
install -p -m 755 _build/bin/oc %{buildroot}%{_datadir}/%{name}/linux/oc
install -p -m 755 _build/bin/darwin_amd64/oc %{buildroot}/%{_datadir}/%{name}/macosx/oc
install -p -m 755 _build/bin/windows_386/oc.exe %{buildroot}/%{_datadir}/%{name}/windows/oc.exe
%endif

#Install pod
install -p -m 755 images/pod/pod %{buildroot}%{_bindir}/

install -d -m 0755 %{buildroot}%{_unitdir}

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig

for cmd in \
    atomic-enterprise \
    kube-apiserver \
    kube-controller-manager \
    kube-proxy \
    kube-scheduler \
    kubelet \
    kubernetes \
    oadm \
    openshift-deploy \
    openshift-docker-build \
    openshift-f5-router \
    openshift-router \
    openshift-sti-build \
    origin
do
    ln -s %{_bindir}/openshift %{buildroot}%{_bindir}/$cmd
done

ln -s oc %{buildroot}%{_bindir}/kubectl

install -d -m 0755 %{buildroot}%{_sysconfdir}/origin/{master,node}

# different service for origin vs aos
install -m 0644 contrib/systemd/%{name}-master.service %{buildroot}%{_unitdir}/%{name}-master.service
install -m 0644 contrib/systemd/%{name}-node.service %{buildroot}%{_unitdir}/%{name}-node.service
# same sysconfig files for origin vs aos
install -m 0644 contrib/systemd/origin-master.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/%{name}-master
install -m 0644 contrib/systemd/origin-node.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/%{name}-node
install -d -m 0755 %{buildroot}%{_prefix}/lib/tuned/%{name}-node-{guest,host}
install -m 0644 contrib/tuned/origin-node-guest/tuned.conf %{buildroot}%{_prefix}/lib/tuned/%{name}-node-guest/tuned.conf
install -m 0644 contrib/tuned/origin-node-host/tuned.conf %{buildroot}%{_prefix}/lib/tuned/%{name}-node-host/tuned.conf
install -d -m 0755 %{buildroot}%{_mandir}/man7

# Patch the manpage for tuned profiles on aos
%if "%{dist}" == ".el7aos"
%{__sed} -e 's|origin-node|atomic-openshift-node|g' \
 -e 's|ORIGIN_NODE|ATOMIC_OPENSHIFT_NODE|' \
 contrib/tuned/man/tuned-profiles-origin-node.7 > %{buildroot}%{_mandir}/man7/tuned-profiles-%{name}-node.7
%else
install -m 0644 contrib/tuned/man/tuned-profiles-origin-node.7 %{buildroot}%{_mandir}/man7/tuned-profiles-%{name}-node.7
%endif

mkdir -p %{buildroot}%{_sharedstatedir}/origin


# Install sdn scripts
install -d -m 0755 %{buildroot}%{_unitdir}/docker.service.d
install -p -m 0644 contrib/systemd/docker-sdn-ovs.conf %{buildroot}%{_unitdir}/docker.service.d/
pushd _thirdpartyhacks/src/%{sdn_import_path}/plugins/osdn/ovs/bin
   install -p -m 755 openshift-sdn-ovs %{buildroot}%{_bindir}/openshift-sdn-ovs
   install -p -m 755 openshift-sdn-docker-setup.sh %{buildroot}%{_bindir}/openshift-sdn-docker-setup.sh
popd
install -d -m 0755 %{buildroot}%{_unitdir}/%{name}-node.service.d
install -p -m 0644 contrib/systemd/openshift-sdn-ovs.conf %{buildroot}%{_unitdir}/%{name}-node.service.d/openshift-sdn-ovs.conf

# Install bash completions
install -d -m 755 %{buildroot}%{_sysconfdir}/bash_completion.d/
install -p -m 644 contrib/completions/bash/* %{buildroot}%{_sysconfdir}/bash_completion.d/
# Generate atomic-enterprise bash completions
%{__sed} -e "s|openshift|atomic-enterprise|g" contrib/completions/bash/openshift > %{buildroot}%{_sysconfdir}/bash_completion.d/atomic-enterprise

%files
%doc README.md
%license LICENSE
%{_bindir}/openshift
%{_bindir}/atomic-enterprise
%{_bindir}/kube-apiserver
%{_bindir}/kube-controller-manager
%{_bindir}/kube-proxy
%{_bindir}/kube-scheduler
%{_bindir}/kubelet
%{_bindir}/kubernetes
%{_bindir}/oadm
%{_bindir}/openshift-deploy
%{_bindir}/openshift-docker-build
%{_bindir}/openshift-f5-router
%{_bindir}/openshift-router
%{_bindir}/openshift-sti-build
%{_bindir}/origin
%{_sharedstatedir}/origin
%{_sysconfdir}/bash_completion.d/atomic-enterprise
%{_sysconfdir}/bash_completion.d/oadm
%{_sysconfdir}/bash_completion.d/openshift
%dir %config(noreplace) %{_sysconfdir}/origin
%ghost %dir %config(noreplace) %{_sysconfdir}/origin
%ghost %config(noreplace) %{_sysconfdir}/origin/.config_managed

%pre
# If /etc/openshift exists and /etc/origin doesn't, symlink it to /etc/origin
if [ -d "%{_sysconfdir}/openshift" ]; then
  if ! [ -d "%{_sysconfdir}/origin"  ]; then
    ln -s %{_sysconfdir}/openshift %{_sysconfdir}/origin
  fi
fi
if [ -d "%{_sharedstatedir}/openshift" ]; then
  if ! [ -d "%{_sharedstatedir}/origin"  ]; then
    ln -s %{_sharedstatedir}/openshift %{_sharedstatedir}/origin
  fi
fi

%files tests
%{_libexecdir}/%{name}
%{_libexecdir}/%{name}/extended.test


%files master
%{_unitdir}/%{name}-master.service
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}-master
%config(noreplace) %{_sysconfdir}/origin/master
%ghost %config(noreplace) %{_sysconfdir}/origin/admin.crt
%ghost %config(noreplace) %{_sysconfdir}/origin/admin.key
%ghost %config(noreplace) %{_sysconfdir}/origin/admin.kubeconfig
%ghost %config(noreplace) %{_sysconfdir}/origin/ca.crt
%ghost %config(noreplace) %{_sysconfdir}/origin/ca.key
%ghost %config(noreplace) %{_sysconfdir}/origin/ca.serial.txt
%ghost %config(noreplace) %{_sysconfdir}/origin/etcd.server.crt
%ghost %config(noreplace) %{_sysconfdir}/origin/etcd.server.key
%ghost %config(noreplace) %{_sysconfdir}/origin/master-config.yaml
%ghost %config(noreplace) %{_sysconfdir}/origin/master.etcd-client.crt
%ghost %config(noreplace) %{_sysconfdir}/origin/master.etcd-client.key
%ghost %config(noreplace) %{_sysconfdir}/origin/master.kubelet-client.crt
%ghost %config(noreplace) %{_sysconfdir}/origin/master.kubelet-client.key
%ghost %config(noreplace) %{_sysconfdir}/origin/master.server.crt
%ghost %config(noreplace) %{_sysconfdir}/origin/master.server.key
%ghost %config(noreplace) %{_sysconfdir}/origin/openshift-master.crt
%ghost %config(noreplace) %{_sysconfdir}/origin/openshift-master.key
%ghost %config(noreplace) %{_sysconfdir}/origin/openshift-master.kubeconfig
%ghost %config(noreplace) %{_sysconfdir}/origin/openshift-registry.crt
%ghost %config(noreplace) %{_sysconfdir}/origin/openshift-registry.key
%ghost %config(noreplace) %{_sysconfdir}/origin/openshift-registry.kubeconfig
%ghost %config(noreplace) %{_sysconfdir}/origin/openshift-router.crt
%ghost %config(noreplace) %{_sysconfdir}/origin/openshift-router.key
%ghost %config(noreplace) %{_sysconfdir}/origin/openshift-router.kubeconfig
%ghost %config(noreplace) %{_sysconfdir}/origin/policy.json
%ghost %config(noreplace) %{_sysconfdir}/origin/serviceaccounts.private.key
%ghost %config(noreplace) %{_sysconfdir}/origin/serviceaccounts.public.key
%ghost %config(noreplace) %{_sysconfdir}/origin/.config_managed

%post master
%systemd_post %{name}-master.service
# Create master config and certs if both do not exist
if [[ ! -e %{_sysconfdir}/origin/master/master-config.yaml &&
     ! -e %{_sysconfdir}/origin/master/ca.crt ]]; then
  %{_bindir}/openshift start master --write-config=%{_sysconfdir}/origin/master
  # Create node configs if they do not already exist
  if ! find %{_sysconfdir}/origin/ -type f -name "node-config.yaml" | grep -E "node-config.yaml"; then
    %{_bindir}/oadm create-node-config --node-dir=%{_sysconfdir}/origin/node/ --node=localhost --hostnames=localhost,127.0.0.1 --node-client-certificate-authority=%{_sysconfdir}/origin/master/ca.crt --signer-cert=%{_sysconfdir}/origin/master/ca.crt --signer-key=%{_sysconfdir}/origin/master/ca.key --signer-serial=%{_sysconfdir}/origin/master/ca.serial.txt --certificate-authority=%{_sysconfdir}/origin/master/ca.crt
  fi
  # Generate a marker file that indicates config and certs were RPM generated
  echo "# Config generated by RPM at "`date -u` > %{_sysconfdir}/origin/.config_managed
fi


%preun master
%systemd_preun %{name}-master.service

%postun master
%systemd_postun

%files node
%{_unitdir}/%{name}-node.service
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}-node
%config(noreplace) %{_sysconfdir}/origin/node
%ghost %config(noreplace) %{_sysconfdir}/origin/.config_managed

%post node
%systemd_post %{name}-node.service

%preun node
%systemd_preun %{name}-node.service

%postun node
%systemd_postun

%files sdn-ovs
%dir %{_unitdir}/docker.service.d/
%dir %{_unitdir}/%{name}-node.service.d/
%{_bindir}/openshift-sdn-ovs
%{_bindir}/openshift-sdn-docker-setup.sh
%{_unitdir}/%{name}-node.service.d/openshift-sdn-ovs.conf
%{_unitdir}/docker.service.d/docker-sdn-ovs.conf

%posttrans sdn-ovs
# This path was installed by older packages but the directory wasn't owned by
# RPM so we need to clean it up otherwise kubelet throws an error trying to
# load the directory as a plugin
if [ -d %{kube_plugin_path} ]; then
  rmdir %{kube_plugin_path}
fi

%files -n tuned-profiles-%{name}-node
%license LICENSE
%{_prefix}/lib/tuned/%{name}-node-host
%{_prefix}/lib/tuned/%{name}-node-guest
%{_mandir}/man7/tuned-profiles-%{name}-node.7*

%post -n tuned-profiles-%{name}-node
recommended=`/usr/sbin/tuned-adm recommend`
if [[ "${recommended}" =~ guest ]] ; then
  /usr/sbin/tuned-adm profile %{name}-node-guest > /dev/null 2>&1
else
  /usr/sbin/tuned-adm profile %{name}-node-host > /dev/null 2>&1
fi

%preun -n tuned-profiles-%{name}-node
# reset the tuned profile to the recommended profile
# $1 = 0 when we're being removed > 0 during upgrades
if [ "$1" = 0 ]; then
  recommended=`/usr/sbin/tuned-adm recommend`
  /usr/sbin/tuned-adm profile $recommended > /dev/null 2>&1
fi

%files clients
%license LICENSE
%{_bindir}/oc
%{_bindir}/kubectl
%{_sysconfdir}/bash_completion.d/oc

%if 0%{?make_redistributable}
%files clients-redistributable
%dir %{_datadir}/%{name}/linux/
%dir %{_datadir}/%{name}/macosx/
%dir %{_datadir}/%{name}/windows/
%{_datadir}/%{name}/linux/oc
%{_datadir}/%{name}/macosx/oc
%{_datadir}/%{name}/windows/oc.exe
%endif

%files dockerregistry
%{_bindir}/dockerregistry

%files pod
%{_bindir}/pod

%files recycle
%{_bindir}/recycle


%changelog
* Fri Apr 29 2016 Martin Milata <mmilata@redhat.com> - 1.1.4-1
- 1.1.4 release

* Mon Feb 08 2016 Martin Milata <mmilata@redhat.com> - 1.1.2-1
- 1.1.2 release

* Wed Feb 03 2016 Martin Milata <mmilata@redhat.com> - 1.1.1-1.osbs
- 1.1.1 release

* Mon Nov 09 2015 Martin Milata <mmilata@redhat.com> - 1.0.8-1.osbs
- 1.0.8 release

* Fri Nov 06 2015 Martin Milata <mmilata@redhat.com> - 1.0.7-1.osbs
- 1.0.7 release
- sync spec with upstream (renamed from openshift to origin)

* Fri Sep 04 2015 Martin Milata <mmilata@redhat.com> - 1.0.5-2.osbs
- remove limit for total size of object annotations

* Wed Aug 26 2015 Martin Milata <mmilata@redhat.com> - 1.0.5-1.osbs
- 1.0.5 release
- sync spec with upstream (major modifications)
  - sdn-ovs and atomic-enterprise subpackages removed

* Wed Jul 15 2015 Tomas Tomecek <ttomecek@redhat.com> - 0.5.2-2.osbs
- add patch to increate timeout of kubelet's apiserver
- add patch to increase number of max pods on kubelet

* Wed May 20 2015 Martin Milata <mmilata@redhat.com> - 0.5.2-1.osbs
- 0.5.2 release
- sync spec with upstream

* Wed May 06 2015 Tomas Tomecek <ttomecek@redhat.com> - 0.5-1.osbs
- 0.5 release

* Mon Apr 27 2015 Tomas Tomecek <ttomecek@redhat.com> - 0.4.4-1.osbs
- new upstream release: 0.4.4

* Fri Apr 24 2015 Martin Milata <mmilata@redhat.com> - 0.4.3-4.osbs
- fix unit file for config generator

* Wed Apr 22 2015 Tomas Tomecek <ttomecek@redhat.com> - 0.4.3-3.osbs
- package config generator actually

* Tue Apr 21 2015 Tomas Tomecek <ttomecek@redhat.com> - 0.4.3-2.osbs
- update configuration

* Fri Apr 17 2015 Tomas Tomecek <ttomecek@redhat.com> - 0.4.1-1.osbs
- 0.4.3

* Fri Mar 27 2015 Tomas Tomecek <ttomecek@redhat.com> - 0.4.1-2.osbs
- update sysconfig file

* Tue Mar 10 2015 Tomas Tomecek <ttomecek@redhat.com> - 0.4.1-1.osbs
- 0.4.1

* Thu Mar 05 2015 Tomas Tomecek <ttomecek@redhat.com> - 0.4.0-1
- 0.4.0

* Thu Feb 26 2015 Scott Dodson <sdodson@redhat.com> 0.3.3-0
- Merge remote-tracking branch 'origin-upstream/master' (sdodson@redhat.com)
- Merge pull request #1169 from sdodson/fix-openshift-node-service
  (bleanhar@redhat.com)
- Merge pull request #1167 from jwforres/fix_usage_comparison
  (dmcphers+openshiftbot@redhat.com)
- Explicitly set --kubeconfig when starting node (sdodson@redhat.com)
- let project admins use resource access review (deads@redhat.com)
- Fix Used vs Max quota comparison in web console (jforrest@redhat.com)
- add context namespacing filter (deads@redhat.com)
- Merge pull request #1165 from liggitt/project_auth_cache
  (dmcphers+openshiftbot@redhat.com)
- Re-enable project auth cache, add UI integration test (jliggitt@redhat.com)
- Merge pull request #1091 from ironcladlou/deploy-retries
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1153 from jwforres/pod_details
  (dmcphers+openshiftbot@redhat.com)
- Output more details on pod details page in web console (jforrest@redhat.com)
- Add controller retry support scaffolding (ironcladlou@gmail.com)
- Merge pull request #1156 from liggitt/start_config
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1116 from pweil-/router-live-probe
  (dmcphers+openshiftbot@redhat.com)
- UPSTREAM: Support AddIfNotPresent function (ironcladlou@gmail.com)
- Fix TLS EOF errors in log at start (jliggitt@redhat.com)
- Ensure create of master policy namespace happens after policy will allow it
  (jliggitt@redhat.com)
- Rework --kubeconfig handler, misc tweaks (jliggitt@redhat.com)
- make start.config immutable (deads@redhat.com)
- Merge pull request #1160 from soltysh/contextdir_conversion
  (dmcphers+openshiftbot@redhat.com)
- Fixed contextDir conversion after moving it from DockerBuildStrategy to
  BuildSource (maszulik@redhat.com)
- Make builder image naming consistent between build strategy describe
  (maszulik@redhat.com)
- Merge pull request #1122 from kargakis/markdown
  (dmcphers+openshiftbot@redhat.com)
- Add verify-jsonformat to Travis (mfojtik@redhat.com)
- Fix formatting and errors in JSON files (mfojtik@redhat.com)
- Added ./hack/verify-jsonformat.sh (mfojtik@redhat.com)
- Merge pull request #1144 from soltysh/image_names
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1152 from colemickens/patch-1
  (dmcphers+openshiftbot@redhat.com)
- Support multiple Dockerfiles with custom-docker-builder
  (cole.mickens@gmail.com)
- Merge pull request #1148 from bparees/remove_local
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1134 from jwforres/build_config_details
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1149 from jwforres/autoupdate_timestamp
  (dmcphers+openshiftbot@redhat.com)
- Set global timer to autoupdate relative timestamps in the UI
  (jforrest@redhat.com)
- Merge pull request #1119 from bparees/optional_output
  (dmcphers+openshiftbot@redhat.com)
- remove use_local env (bparees@redhat.com)
- Builds page - group builds by build config and show more details for build
  configs (jforrest@redhat.com)
- Merge pull request #1146 from bparees/generator_ruby_ref
  (dmcphers+openshiftbot@redhat.com)
- make build output optional (bparees@redhat.com)
- use ruby-20-centos7 in generated buildconfig (bparees@redhat.com)
- Use --from-build flag only for re-running builds
  (kargakis@users.noreply.github.com)
- Changed image names for ImageRepository objects, since it was using two
  exactly the same in different tests (maszulik@redhat.com)
- add liveness probe to router (pweil@redhat.com)
- Fix docs (kargakis@users.noreply.github.com)
- Merge pull request #1138 from mfojtik/sti_rebase2
  (dmcphers+openshiftbot@redhat.com)
- Rename 'Clean' to 'Incremental' in STI builder (mfojtik@redhat.com)
- Changed Info->Infof to have the variable printed (maszulik@redhat.com)
- Merge pull request #1097 from jwforres/integration_tests
  (dmcphers+openshiftbot@redhat.com)
- Add optional e2e UI tests (jforrest@redhat.com)
- bump(github.com/openshift/source-to-
  image):c0c154efcba27ea5693c428bfe28560c220b4850 (mfojtik@redhat.com)
- Make cli examples consistent across OpenShift
  (kargakis@users.noreply.github.com)
- Merge pull request #1127 from kargakis/api-consistency
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1124 from akram/patch-1
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1086 from csrwng/bug_1190577
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1093 from csrwng/bug_1190575
  (dmcphers+openshiftbot@redhat.com)
- Merge remote-tracking branch 'origin-upstream/master' (sdodson@redhat.com)
- Merge pull request #1110 from liggitt/username_validation
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1132 from ironcladlou/rollback-cli-printer-fix
  (dmcphers+openshiftbot@redhat.com)
- Validate usernames don't contain problematic URL sequences
  (jliggitt@redhat.com)
- Merge pull request #1131 from ironcladlou/deploy-generatename-fix
  (dmcphers+openshiftbot@redhat.com)
- Use a versioned printer for rollback configs (ironcladlou@gmail.com)
- Fix broken deployer pod GenerateName reference (ironcladlou@gmail.com)
- update must gather for policy (deads@redhat.com)
- Generate: handle image with multiple ports in EXPOSE statement
  (cewong@redhat.com)
- Update command parameter and help text to refer to single port
  (cewong@redhat.com)
- Merge pull request #1104 from deads2k/deads-update-readme
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1113 from deads2k/deads-pretty-up-describe
  (dmcphers+openshiftbot@redhat.com)
- update readme to take advantage of authorization (deads@redhat.com)
- Merge pull request #1095 from csrwng/bug_1194487
  (dmcphers+openshiftbot@redhat.com)
- Cleanup dangling images from cache (sdodson@redhat.com)
- Make Clients API consistent (kargakis@users.noreply.github.com)
- Add htpasswd SHA/MD5 support (jliggitt@redhat.com)
- Merge pull request #1077 from liggitt/kubeconfig_public_master_context
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1107 from soltysh/rename_base_image
  (dmcphers+openshiftbot@redhat.com)
- route definition requires name in metadata (akram.benaissi@free.fr)
- Rename BaseImage -> Image for DockerBuildStrategy to be consistent with
  STIBuilderStrategy about field naming (maszulik@redhat.com)
- Generate master and public-master .kubeconfig contexts (jliggitt@redhat.com)
- Add options to clear authorization headers for basic/bearer auth
  (jliggitt@redhat.com)
- Merge pull request #1114 from bparees/build_names
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1108 from deads2k/deads-create-policy-cache
  (dmcphers+openshiftbot@redhat.com)
- better build names (bparees@redhat.com)
- Merge pull request #1100 from smarterclayton/add_registry_create_command
  (dmcphers+openshiftbot@redhat.com)
- pretty up policy describer (deads@redhat.com)
- UPSTREAM: get the keys from a string map (deads@redhat.com)
- create policy cache (deads@redhat.com)
- Merge pull request #967 from goldmann/service_fixes
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1112 from liggitt/deny_password
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1111 from danmcp/master
  (dmcphers+openshiftbot@redhat.com)
- Add ose-docker-registry to ose-build script (sdodson@redhat.com)
- Add 'deny' password authenticator (jliggitt@redhat.com)
- Fix case (dmcphers@redhat.com)
- Add a command to install / check a registry (ccoleman@redhat.com)
- Merge pull request #1101 from soltysh/card426
  (dmcphers+openshiftbot@redhat.com)
- Merge remote-tracking branch 'origin-upstream/master' (sdodson@redhat.com)
- Automatic commit of package [openshift] release [0.3.2-0].
  (sdodson@redhat.com)
- Merge tag 'v0.3.2' (sdodson@redhat.com)
- refactor authorization for sanity (deads@redhat.com)
- Card devexp_426 - Force clean builds by default for STI (maszulik@redhat.com)
- Better management of the systemd services (marek.goldmann@gmail.com)
- Merge pull request #1087 from csrwng/bug_1190578
  (dmcphers+openshiftbot@redhat.com)
- Bug 1194487 - Fix generate command repository detection (cewong@redhat.com)
- Bug 1190578 - Should prompt clear error when generate an application list
  code in a non-source code repository. (cewong@redhat.com)
- First hack at docker builds for OSE (bleanhar@redhat.com)
- Merge remote-tracking branch 'upstream/master' (bleanhar@redhat.com)
- Merge remote-tracking branch 'origin-upstream/master' (sdodson@redhat.com)
- Bump specfile 0.3.1 (sdodson@redhat.com)
- Merge tag 'v0.3.1' (sdodson@redhat.com)
- Revert "Drop the version variable from --images for now" (sdodson@redhat.com)
- Merge remote-tracking branch 'origin-sdodson/set-images-format'
  (sdodson@redhat.com)
- Fix .el7dist string (sdodson@redhat.com)
- Merge remote-tracking branch 'origin-sdodson/set-images-format'
  (sdodson@redhat.com)
- Merge tag 'v0.3' (sdodson@redhat.com)
- Update the custom tagger and builder to provide OpenShift ldflags
  (sdodson@redhat.com)
- Drop the version variable from --images for now (sdodson@redhat.com)
- Attempt to manipulate images path conditionally (sdodson@redhat.com)
- Merge remote-tracking branch 'origin-upstream/master' (sdodson@redhat.com)
- Merge remote-tracking branch 'origin-upstream/master' (sdodson@redhat.com)
- Automatic commit of package [openshift] release [0.2.2-0].
  (sdodson@redhat.com)
- Merge tag 'v0.2.2' (sdodson@redhat.com)
- Merge remote-tracking branch 'origin-upstream/master' (sdodson@redhat.com)
- Automatic commit of package [openshift] release [0.2.1-4].
  (sdodson@redhat.com)

* Mon Feb 23 2015 Scott Dodson <sdodson@redhat.com> 0.3.2-0
- Merge tag 'v0.3.2' (sdodson@redhat.com)
- Merge pull request #1087 from csrwng/bug_1190578
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1088 from bparees/update_sti
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1092 from smarterclayton/run_integration_in_serial
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1094 from bparees/clone_buildcfg_labels
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #971 from derekwaynecarr/acl_cache
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1096 from bparees/master
  (dmcphers+openshiftbot@redhat.com)
- Fix loop period to stop pegging CPU, add project-spawner (decarr@redhat.com)
- List projects enforces authorization (decarr@redhat.com)
- Merge pull request #1090 from csrwng/bug_1190576
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1043 from smarterclayton/add_router_command
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1051 from deads2k/deads-prevent-escalation
  (dmcphers+openshiftbot@redhat.com)
- fix formatting (bparees@redhat.com)
- Integration tests need to run in separate processes (ccoleman@redhat.com)
- Merge pull request #1085 from liggitt/upgrade_with_auth
  (dmcphers+openshiftbot@redhat.com)
- Bug 1190578 - Should prompt clear error when generate an application list
  code in a non-source code repository. (cewong@redhat.com)
- copy build labels from buildconfig (bparees@redhat.com)
- Update test cases and docs to use `openshift ex router` (ccoleman@redhat.com)
- prevent privilege escalation (deads@redhat.com)
- Add a router command to install / check the routers (ccoleman@redhat.com)
- UPSTREAM: Expose converting client.Config files to Data (ccoleman@redhat.com)
- Merge pull request #982 from csrwng/template_labels
  (dmcphers+openshiftbot@redhat.com)
- Remove cors headers from proxied connections (jliggitt@redhat.com)
- Strip auth headers before proxying, add auth headers on upgrade requests
  (jliggitt@redhat.com)
- Strip access_token param from requests in auth layer (jliggitt@redhat.com)
- Bug 1190576: Improve error message when trying to use non-existent reference
  (cewong@redhat.com)
- bump(github.com/openshift/source-to-
  image):ad5adc054311686baf316cd8bf91c4d42ae1bd4e (bparees@redhat.com)
- Merge pull request #1081 from csrwng/fix_json
  (dmcphers+openshiftbot@redhat.com)
- Improve help for creating / being added to new projects (jliggitt@redhat.com)
- Fix dangling commas in example json files (cewong@redhat.com)
- First hack at docker builds for OSE (bleanhar@redhat.com)
- Add labels to templates (cewong@redhat.com)
- Merge remote-tracking branch 'upstream/master' (bleanhar@redhat.com)
- Vagrantfile: default libvirt box now with actual openshift
  (lmeyer@redhat.com)
- Merge pull request #1076 from bparees/image_links
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1075 from deads2k/deads-add-namespaces
  (dmcphers+openshiftbot@redhat.com)
- document sti images (bparees@redhat.com)
- Merge pull request #1066 from liggitt/kubeconfig_inline_cert
  (dmcphers+openshiftbot@redhat.com)
- Update docs (jliggitt@redhat.com)
- add namespaces to authorization rules (deads@redhat.com)
- Inline bootstrapped certs in client .kubeconfig files (jliggitt@redhat.com)
- UPSTREAM: Let .kubeconfig populate ca/cert/key data and basic-auth
  username/password in client configs (jliggitt@redhat.com)
- Merge pull request #998 from deads2k/deads-handle-non-resource-urls
  (dmcphers+openshiftbot@redhat.com)
- authorize non-resource urls (deads@redhat.com)
- Merge pull request #1068 from liggitt/kubeconfig_check
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1063 from bparees/remove_local
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #996 from pweil-/route-validate-name
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1072 from bparees/docker_regex
  (dmcphers+openshiftbot@redhat.com)
- use multiline in regex matching (bparees@redhat.com)
- Merge pull request #1071 from jwforres/service_selector_bug
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1024 from mfojtik/sti_rebase
  (dmcphers+openshiftbot@redhat.com)
- Handle empty label selectors in web console (jforrest@redhat.com)
- Remove dead links from cli doc (kargakis@users.noreply.github.com)
- Capture errors from BuildParameters conversion (mfojtik@redhat.com)
- Fix integration (mfojtik@redhat.com)
- Move ContextDir under BuildSource (mfojtik@redhat.com)
- Add support for ContextDir in STI build (mfojtik@redhat.com)
- Fix Origin code to incorporate changes in STI (mfojtik@redhat.com)
- bump(github.com/openshift/source-to-image):
  1338bff33b5c46acc02840f88a9b576a1b1fa404 (mfojtik@redhat.com)
- bump(github.com/fsouza/go-
  dockerclient):e1e2cc5b83662b894c6871db875c37eb3725a045 (mfojtik@redhat.com)
- UPSTREAM: Surface load errors when reading .kubeconfig files
  (jliggitt@redhat.com)
- Merge pull request #1054 from smarterclayton/tag_built_images
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1062 from mnagy/fix_bash_substitution
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1013 from deads2k/deads-respect-namesapce
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1028 from jwforres/overview_edge_cases
  (dmcphers+openshiftbot@redhat.com)
- Handle k8s edge cases in the web console overview (jforrest@redhat.com)
- Merge pull request #1059 from ppalaga/150218-etcd-clone-or-fetch
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1047 from derekwaynecarr/turn_on_quota_controller
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1064 from deads2k/deads-reduce-logging-verbosity-somehow-
  this-will-be-wrong (dmcphers+openshiftbot@redhat.com)
- Give our local built docker images unique ids, and push that id
  (ccoleman@redhat.com)
- UPSTREAM: move setSelfLink logging to v(5) (deads@redhat.com)
- make useLocalImages the default and remove configurability
  (bparees@redhat.com)
- Fix build-in-docker.sh, use $(), not ${} (nagy.martin@gmail.com)
- validate route name and host (pweil@redhat.com)
- make sure rolebinding names are unique (deads@redhat.com)
- Use git fetch && reset if the given repo was cloned already
  (ppalaga@redhat.com)
- Replacing old openshift/nodejs-0-10-centos with new
  openshift/nodejs-010-centos7 (j.hadvig@gmail.com)
- Merge pull request #1050 from ironcladlou/deploy-error-refactor
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1040 from smarterclayton/add_template_api
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1053 from danmcp/master
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1052 from smarterclayton/cleanup_factories
  (dmcphers+openshiftbot@redhat.com)
- Fixing typos (dmcphers@redhat.com)
- Merge pull request #1038 from derekwaynecarr/project_is_namespace
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1049 from deads2k/deads-fix-namespace-requirement
  (dmcphers+openshiftbot@redhat.com)
- Project is Kubernetes Namespace (decarr@redhat.com)
- Merge remote-tracking branch 'origin-upstream/master' (sdodson@redhat.com)
- Refactor deploy package for error handling support (ironcladlou@gmail.com)
- ignore selflinking error (deads@redhat.com)
- Merge pull request #1026 from deads2k/deads-tidy-up-policy.md
  (dmcphers+openshiftbot@redhat.com)
- Implement a Template REST endpoint using the generic store
  (ccoleman@redhat.com)
- sync policy doc to reality (deads@redhat.com)
- Merge pull request #1046 from ironcladlou/release-tar-naming
  (dmcphers+openshiftbot@redhat.com)
- Turn on resource quota manager to collect usage stats (decarr@redhat.com)
- Improve release tar naming (ironcladlou@gmail.com)
- Explicit build (ccoleman@redhat.com)
- Merge pull request #897 from ironcladlou/cross-compile-image-binaries
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1036 from deads2k/deads-use-kube-attributes
  (dmcphers+openshiftbot@redhat.com)
- Platform independent image builds (ironcladlou@gmail.com)
- bump(github.com/GoogleCloudPlatform/kubernetes/plugin/pkg/admission:c977a4586
  42b4dbd8c3ad9cfc9eecafc85fb6183) (decarr@redhat.com)
- Add compile dependency for Kubernetes admission control plugins
  (decarr@redhat.com)
- switch to kubernetes authorization info (deads@redhat.com)
- UPSTREAM: expose info resolver (deads@redhat.com)
- Remove GOPATH from build-in-docker.sh script (mfojtik@redhat.com)
- Unify all client Factories into one location (ccoleman@redhat.com)
- Merge pull request #930 from sdodson/set-images-format
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1017 from kargakis/doc (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1027 from danmcp/master
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1030 from liggitt/request_context_map
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1015 from kargakis/minor-fix
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1031 from jwforres/add_fixtures_edge_cases
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1032 from mfojtik/install-registry
  (dmcphers+openshiftbot@redhat.com)
- Move coverage output processing to the end (dmcphers@redhat.com)
- Merge pull request #1039 from pweil-/router-websockets
  (dmcphers+openshiftbot@redhat.com)
- Switch to using request context mapper (jliggitt@redhat.com)
- Merge pull request #999 from deads2k/deads-create-project
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1033 from liggitt/htmlmin
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1029 from jwforres/fix_namespaced_urls
  (dmcphers+openshiftbot@redhat.com)
- router websocket support (pweil@redhat.com)
- Merge pull request #1008 from nak3/Added-missing-Requires
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1023 from bparees/custom_builder
  (dmcphers+openshiftbot@redhat.com)
- add new-project command (deads@redhat.com)
- Add fixtures to test edge cases in the web console (jforrest@redhat.com)
- Fix htmlmin linebreak issue (jliggitt@redhat.com)
- Provide useful message when CERT_DIR is not set in install-registry.sh
  (mfojtik@redhat.com)
- Switch namespaced URL paths from ns/ to namespaces/ (jforrest@redhat.com)
- Bump specfile 0.3.1 (sdodson@redhat.com)
- Merge tag 'v0.3.1' (sdodson@redhat.com)
- Merge pull request #1018 from rhcarvalho/typokiller
  (dmcphers+openshiftbot@redhat.com)
- UPSTREAM: Distinguish between NamespaceAll and NamespaceDefault
  (ccoleman@redhat.com)
- use origin-base for base image (bparees@redhat.com)
- e2e without root fails because certs can't be viewed by wait_for_url
  (ccoleman@redhat.com)
- Tolerate Docker not being present when using all-in-one (ccoleman@redhat.com)
- Update registries to remove async channel (ccoleman@redhat.com)
- Compile time changes (ccoleman@redhat.com)
- UPSTREAM: Fix cross-namespace queries (ccoleman@redhat.com)
- UPSTREAM: Allow kubelet to run without Docker (ccoleman@redhat.com)
- UPSTREAM: Allow SetList to work against api.List (ccoleman@redhat.com)
- UPSTREAM: Disable auto-pull when tag is "latest" (ccoleman@redhat.com)
- UPSTREAM: Disable UIs for Kubernetes and etcd (ccoleman@redhat.com)
- UPSTREAM: Add 'release' field to raven-go (ccoleman@redhat.com)
- UPSTREAM: special command "help" must be aware of context
  (contact@fabianofranz.com)
- UPSTREAM: need to make sure --help flags is registered before calling pflag
  (contact@fabianofranz.com)
- bump(github.com/GoogleCloudPlatform/kubernetes):c977a458642b4dbd8c3ad9cfc9eec
  afc85fb6183 (ccoleman@redhat.com)
- Stop referencing kubecfg now that it is deleted upstream
  (ccoleman@redhat.com)
- Fix several typos (rhcarvalho@gmail.com)
- Note on using docker with --insecure-registry
  (kargakis@users.noreply.github.com)
- Use p12-encoded certs on OS X (jliggitt@redhat.com)
- Initialize image by using struct literal (kargakis@users.noreply.github.com)
- Merge pull request #800 from deads2k/deads-the-rest-of-policy
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1009 from deads2k/deads-upstream-kubeconfig-merge
  (dmcphers+openshiftbot@redhat.com)
- *AccessReviews (deads@redhat.com)
- pass authorizer/attributebuilder pair into master (deads@redhat.com)
- Merge pull request #990 from kargakis/prof-comment
  (dmcphers+openshiftbot@redhat.com)
- Revert "Drop the version variable from --images for now" (sdodson@redhat.com)
- Update the custom tagger and builder to provide OpenShift ldflags
  (sdodson@redhat.com)
- Merge pull request #1004 from liggitt/logout_uri
  (dmcphers+openshiftbot@redhat.com)
- put templates in correct dir for install registry script (bparees@redhat.com)
- UPSTREAM: properly handle mergo map versus value rules: 4416
  (deads@redhat.com)
- Add missing Requires (nakayamakenjiro@gmail.com)
- Explain why Stop is called like that (michaliskargakis@gmail.com)
- Merge pull request #993 from kargakis/validate
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1002 from bparees/run_in_container
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1003 from deads2k/deads-tolerate-missing-role
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #1000 from liggitt/qualify_certs
  (dmcphers+openshiftbot@redhat.com)
- Allow setting final logout uri (jliggitt@redhat.com)
- Merge pull request #1001 from danmcp/master
  (dmcphers+openshiftbot@redhat.com)
- tolerate missing roles (deads@redhat.com)
- Merge pull request #991 from deads2k/deads-make-user-tilde-work
  (dmcphers+openshiftbot@redhat.com)
- update in-container steps to setup registry properly (bparees@redhat.com)
- Making race an option for sh scripts (dmcphers@redhat.com)
- Merge pull request #995 from danmcp/master (dmcphers+openshiftbot@redhat.com)
- Fixing test coverage reporting (dmcphers@redhat.com)
- Generate client configs for nodes, provider-qualify and add groups to certs
  (jliggitt@redhat.com)
- Merge pull request #994 from jwforres/use_label_selector
  (dmcphers+openshiftbot@redhat.com)
- add resourceName to policy (deads@redhat.com)
- Merge pull request #989 from soltysh/issue865
  (dmcphers+openshiftbot@redhat.com)
- Use LabelSelector in overview to associate pods to a service
  (jforrest@redhat.com)
- Issue 865: Fixed build integration tests. (maszulik@redhat.com)
- Validate image repository (michaliskargakis@gmail.com)
- Merge pull request #985 from liggitt/prevent_panic
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #986 from jwforres/namespace_in_path
  (dmcphers+openshiftbot@redhat.com)
- Fix off-by-1 error (jliggitt@redhat.com)
- Support namespace in path for requesting k8s api from web console
  (jforrest@redhat.com)
- Bug 1191824 - Fixing typo (bleanhar@redhat.com)
- Merge pull request #978 from mnagy/fix_logging
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #974 from soltysh/copyright_removal
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #984 from dobbymoodge/service_order_fixup
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #954 from jwforres/quota
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #983 from liggitt/auth_config
  (dmcphers+openshiftbot@redhat.com)
- Require network when starting openshift-master (jolamb@redhat.com)
- Add project settings page and show quota and limit ranges for the project
  (jforrest@redhat.com)
- Attempt to manipulate images path conditionally (sdodson@redhat.com)
- Merge pull request #981 from fabianofranz/osc_login_further
  (dmcphers+openshiftbot@redhat.com)
- Change ORIGIN_OAUTH_* env vars to OPENSHIFT_OAUTH_* (jliggitt@redhat.com)
- Merge pull request #980 from liggitt/unify_user
  (dmcphers+openshiftbot@redhat.com)
- Bug 1191354 - must save username to .kubeconfig correctly
  (contact@fabianofranz.com)
- Merge pull request #979 from deads2k/deads-add-policy-watches
  (dmcphers+openshiftbot@redhat.com)
- Use kubernetes user.Info interface (jliggitt@redhat.com)
- Merge pull request #977 from brenton/master
  (dmcphers+openshiftbot@redhat.com)
- add policy watches (deads@redhat.com)
- Merge pull request #970 from jwforres/console_v1beta3
  (dmcphers+openshiftbot@redhat.com)
- Update the web console to request k8s api on v1beta3 (jforrest@redhat.com)
- Use Warningf instead of Warning so formatting works (nagy.martin@gmail.com)
- Bug 1190095 - useless entry "nameserver <nil>" is in docker container
  resolv.conf (bleanhar@redhat.com)
- deploymentconfigs permission typo (deads@redhat.com)
- Removed all Google copyrights leftovers (maszulik@redhat.com)
- Merge pull request #962 from goldmann/docker_vagrant
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #885 from deads2k/deads-tighten-bootstrap-policy
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #966 from mnagy/chown_docker_build_output
  (dmcphers+openshiftbot@redhat.com)
- e2e formatting (deads@redhat.com)
- tighten bootstrap policy (deads@redhat.com)
- Default session secret to unknowable value (jliggitt@redhat.com)
- Make token lifetimes configurable (jliggitt@redhat.com)
- Allow denying a prompted OAuth grant (jliggitt@redhat.com)
- Make user header configurable (jliggitt@redhat.com)
- Merge pull request #953 from deads2k/deads-smarter-kubeconfig-merge
  (dmcphers+openshiftbot@redhat.com)
- remove deny and negations (deads@redhat.com)
- Use chown for build-in-docker.sh output binaries (nagy.martin@gmail.com)
- Make sure vagrant development environment works well with new docker-io
  (marek.goldmann@gmail.com)
- Merge remote-tracking branch 'origin-sdodson/set-images-format'
  (sdodson@redhat.com)
- Fix .el7dist string (sdodson@redhat.com)
- move cleanup to its own section (bparees@redhat.com)
- Merge pull request #951 from pweil-/router-sample-app
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #957 from liggitt/auth_tweaks
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #955 from liggitt/browser_cert_prompt
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #956 from danmcp/master (dmcphers+openshiftbot@redhat.com)
- Comment on redirecting to login on 0 codes (jliggitt@redhat.com)
- Add better instructions around using vagrant (dmcphers@redhat.com)
- Prevent browsers from prompting to send bogus client certs
  (jliggitt@redhat.com)
- Merge pull request #952 from liggitt/mime (dmcphers+openshiftbot@redhat.com)
- add edge terminated route to sample app (pweil@redhat.com)
- make more intelligent kubeconfig merge (deads@redhat.com)
- Merge pull request #950 from liggitt/example
  (dmcphers+openshiftbot@redhat.com)
- Register used mime types (jliggitt@redhat.com)
- use tags from imagerepos when constructing new builds (bparees@redhat.com)
- Update example project json (jliggitt@redhat.com)
- Merge pull request #946 from mnagy/test_selinux_labels
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #921 from kargakis/various-fixes
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #945 from kargakis/fix (dmcphers+openshiftbot@redhat.com)
- Merge pull request #943 from smarterclayton/generate_shorter_tags
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #898 from ironcladlou/pod-deployment-annotations
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #886 from pweil-/make-skip-build
  (dmcphers+openshiftbot@redhat.com)
- Check SELinux labels when building in docker (nagy.martin@gmail.com)
- Merge pull request #937 from liggitt/html_newlines
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #939 from deads2k/deads-fix-remove-group
  (dmcphers+openshiftbot@redhat.com)
- Various idiomatic fixes throughout the repo (michaliskargakis@gmail.com)
- Check for unspecified port once (michaliskargakis@gmail.com)
- Merge remote-tracking branch 'origin-sdodson/set-images-format'
  (sdodson@redhat.com)
- Merge tag 'v0.3' (sdodson@redhat.com)
- Generate shorter tags when building release tars (ccoleman@redhat.com)
- Update the custom tagger and builder to provide OpenShift ldflags
  (sdodson@redhat.com)
- Merge pull request #940 from smarterclayton/warn_on_empty_repo
  (dmcphers+openshiftbot@redhat.com)
- Update start help (ccoleman@redhat.com)
- Tweak the flag for --images to indicate applies to master and node
  (ccoleman@redhat.com)
- Merge pull request #938 from csrwng/build_logging
  (dmcphers+openshiftbot@redhat.com)
- Improve the default osc help page (ccoleman@redhat.com)
- Display more information when an app is automatically created
  (ccoleman@redhat.com)
- make remove-group from role check all bindings (deads@redhat.com)
- Improve error handling and logging for builds (cewong@redhat.com)
- UPSTREAM: Use name from server when displaying create/update
  (ccoleman@redhat.com)
- Drop the version variable from --images for now (sdodson@redhat.com)
- Attempt to manipulate images path conditionally (sdodson@redhat.com)
- Merge pull request #922 from sdodson/ootb-configs
  (dmcphers+openshiftbot@redhat.com)
- Correlate deployed pods with their deployments (ironcladlou@gmail.com)
- Remove comments from minified HTML (jliggitt@redhat.com)
- Preserve newlines in html (jliggitt@redhat.com)
- Merge pull request #924 from ncdc/proxy-upgrade
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #934 from csrwng/handle_multiple_matches
  (dmcphers+openshiftbot@redhat.com)
- Add upgrade-aware HTTP proxy (agoldste@redhat.com)
- Merge pull request #932 from liggitt/user_init
  (dmcphers+openshiftbot@redhat.com)
- Handle multiple builder matches in generate command (cewong@redhat.com)
- Merge pull request #931 from liggitt/osc_oauth_describers
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #904 from smarterclayton/enable_new_app
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #929 from fabianofranz/fix_help_usability
  (dmcphers+openshiftbot@redhat.com)
- OAuth api printers (jliggitt@redhat.com)
- Set user fullname correctly, initialize identity mappings fully
  (jliggitt@redhat.com)
- Merge pull request #923 from liggitt/delete_token_on_logout
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #928 from sdodson/fix-tuned-profile
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #830 from fabianofranz/osc_login
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #927 from bparees/fix_scripts_url
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #918 from jwforres/bug_1189390_empty_project_selector
  (dmcphers+openshiftbot@redhat.com)
- Set KUBECONFIG path for openshift-node (sdodson@redhat.com)
- Sort ports for service generation and select first port (cewong@redhat.com)
- Enable `osc new-app` and simplify some of the rough edges for launch
  (ccoleman@redhat.com)
- Command for displaying global options is "osc options" in help
  (contact@fabianofranz.com)
- Delete token on logout (jliggitt@redhat.com)
- Merge pull request #926 from jwforres/start_node_kubeconfig
  (dmcphers+openshiftbot@redhat.com)
- Syntax consistency between help templates (contact@fabianofranz.com)
- Merge pull request #916 from liggitt/localStorage
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #858 from ironcladlou/image-trigger-matching-fix
  (dmcphers+openshiftbot@redhat.com)
- Fixes base command reference (osc || openshift cli) in help
  (contact@fabianofranz.com)
- Merge pull request #784 from mfojtik/docs_update
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #910 from ironcladlou/enhance-deployment-describer
  (dmcphers+openshiftbot@redhat.com)
- RPMs: Fix upgrades for the tuned profile (sdodson@redhat.com)
- Better footer messages in help (contact@fabianofranz.com)
- Fix help line breaks (contact@fabianofranz.com)
- Remove the usage from the list of available commands in help
  (contact@fabianofranz.com)
- modify .kubeconfig (deads@redhat.com)
- Basic structure for osc login (contact@fabianofranz.com)
- Merge pull request #911 from ironcladlou/pod-diff-fix
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #900 from liggitt/expire_session
  (dmcphers+openshiftbot@redhat.com)
- fix scripts http url to https (bparees@redhat.com)
- Start node with --kubeconfig should use master host from config file
  (jforrest@redhat.com)
- Bug 1189390 - fix project selector so it gets re-rendered after project list
  changes (jforrest@redhat.com)
- Switch to localStorage (jliggitt@redhat.com)
- Fix image change trigger imageRepo matching (ironcladlou@gmail.com)
- Show latest deployment in deploy config describe (ironcladlou@gmail.com)
- Merge pull request #901 from liggitt/tweak_projects_css
  (dmcphers+openshiftbot@redhat.com)
- Merge remote-tracking branch 'origin-upstream/master' (sdodson@redhat.com)
- Merge pull request #913 from ncdc/warn_on_chcon_only
  (dmcphers+openshiftbot@redhat.com)
- Update documentation to use 'osc create' consistently (mfojtik@redhat.com)
- Tighten header styles inside tiles (jliggitt@redhat.com)
- Only warn when chcon fails (ccoleman@redhat.com)
- Restore logic to disregard resources in pod diff (ironcladlou@gmail.com)
- Merge pull request #890 from fabianofranz/fix_more_help_issues
  (dmcphers+openshiftbot@redhat.com)
- UPSTREAM: Register nodes that already exist statically (ccoleman@redhat.com)
- Only allow session auth to be used for a single auth flow
  (jliggitt@redhat.com)
- Merge pull request #895 from rajatchopra/master
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #892 from sdodson/gitignore-pyc
  (dmcphers+openshiftbot@redhat.com)
- Remove aliases and options command from cli template
  (contact@fabianofranz.com)
- Merge pull request #891 from smarterclayton/add_user_agent
  (dmcphers+openshiftbot@redhat.com)
- make ovs-simple from openshift-sdn the default networking solution for
  vagrant (rchopra@redhat.com)
- Merge pull request #894 from mrunalp/vagrant_certs
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #872 from bparees/remove_guestbook
  (dmcphers+openshiftbot@redhat.com)
- Use certs in vagrant mutli node environment. (mrunalp@gmail.com)
- Merge pull request #835 from pweil-/reencrypt-validation
  (dmcphers+openshiftbot@redhat.com)
- Nuke the default usage section from client templates
  (contact@fabianofranz.com)
- Introduces "osc options" to list global options (contact@fabianofranz.com)
- Custom template for cli and osc, hide global options
  (contact@fabianofranz.com)
- Merge pull request #888 from bparees/update_readme
  (dmcphers+openshiftbot@redhat.com)
- Merge remote-tracking branch 'origin-upstream/master' (sdodson@redhat.com)
- fix service select for frontend (bparees@redhat.com)
- Merge pull request #855 from liggitt/login (dmcphers+openshiftbot@redhat.com)
- Ignore .pyc files (sdodson@redhat.com)
- OpenShift should set a client UserAgent on all calls (ccoleman@redhat.com)
- Merge pull request #884 from bparees/imagerepo_template
  (dmcphers+openshiftbot@redhat.com)
- Add OAuth login to console (jliggitt@redhat.com)
- Set a default user agent on all client.Client calls (ccoleman@redhat.com)
- remove use of osc namespace command (bparees@redhat.com)
- create template file for image repos (bparees@redhat.com)
- Merge pull request #883 from danmcp/master (dmcphers+openshiftbot@redhat.com)
- add skip build flag support for test target (pweil@redhat.com)
- Merge pull request #881 from bparees/dockerrepository
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #794 from csrwng/experimental_appgen
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #882 from smarterclayton/increase_timeout_on_test_cmd
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #880 from bparees/update_readme
  (dmcphers+openshiftbot@redhat.com)
- Remove references to openshift/kubernetes (dmcphers@redhat.com)
- use Status.DockerImageRepository instead of DockerImageRepository
  (bparees@redhat.com)
- Merge pull request #878 from jwhonce/docs (dmcphers+openshiftbot@redhat.com)
- Merge pull request #877 from jwforres/fix_console_ie
  (dmcphers+openshiftbot@redhat.com)
- Reorganize command line code and move app-gen under experimental
  (cewong@redhat.com)
- Slightly increase the wait for hack/test-cmd.sh (ccoleman@redhat.com)
- Merge pull request #868 from smarterclayton/rebase_kube
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #857 from ncdc/chcon-volumes-dir
  (dmcphers+openshiftbot@redhat.com)
- WIP - osc new-app with argument inference (ccoleman@redhat.com)
- [WIP] Simple generation flow for an application based on source
  (cewong@redhat.com)
- Simple source->build->deploy generation (ccoleman@redhat.com)
- Merge pull request #876 from smarterclayton/typo_in_master
  (dmcphers+openshiftbot@redhat.com)
- remove guestbook link (bparees@redhat.com)
- Merge pull request #864 from smarterclayton/release_push_guidelines
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #863 from smarterclayton/fix_end_to_end
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #853 from deads2k/deads-cli
  (dmcphers+openshiftbot@redhat.com)
- Add missing step when testing k8s rebase (jhonce@redhat.com)
- Merge pull request #869 from smarterclayton/restore_original_cors
  (dmcphers+openshiftbot@redhat.com)
- Bug 1188933 - Missing es5-dom-shim causes CustomEvent polyfill to fail in IE
  (jforrest@redhat.com)
- Resource round tripping has been fixed and new fields added to pod
  (ccoleman@redhat.com)
- Master takes IP instead of string (ccoleman@redhat.com)
- Use RESTMapper scopes for registering resources (ccoleman@redhat.com)
- UPSTREAM: Disable UIs for Kubernetes and etcd (ccoleman@redhat.com)
- UPSTREAM: Disable auto-pull when tag is "latest" (ccoleman@redhat.com)
- UPSTREAM: spf13/cobra help display separate groups of flags
  (contact@fabianofranz.com)
- UPSTREAM: Add 'release' field to raven-go (ccoleman@redhat.com)
- bump(github.com/GoogleCloudPlatform/kubernetes):72ad4f12bd7408a6f75e6a0bf37b3
  440e165bdf4 (ccoleman@redhat.com)
- hack/end-to-end should terminate jobs (ccoleman@redhat.com)
- Set volume dir SELinux context if possible (agoldste@redhat.com)
- Typo on master.go around pullIfNotPresent (ccoleman@redhat.com)
- Update HACKING.md with the release push instructions (ccoleman@redhat.com)
- Bash is the worst programming language ever invented (ccoleman@redhat.com)
- Restore CORS outside of go-restful (ccoleman@redhat.com)
- Merge pull request #854 from fabianofranz/fix_help_issues
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #873 from bparees/simplify_readme
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #860 from bparees/check_dockerfile
  (dmcphers+openshiftbot@redhat.com)
- use start-build instead of curl (bparees@redhat.com)
- Merge pull request #870 from mfojtik/context_dir
  (dmcphers+openshiftbot@redhat.com)
- Add CONTEXT_DIR support for sti-image-builder image (mfojtik@redhat.com)
- Merge pull request #845 from mnagy/add_upstream_update
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #866 from danmcp/master (dmcphers+openshiftbot@redhat.com)
- Generate openshift service on provision (dmcphers@redhat.com)
- check for error on missing docker file (bparees@redhat.com)
- Adding tests for help consistency to test-cmd.sh (contact@fabianofranz.com)
- UPSTREAM: special command "help" must be aware of context
  (contact@fabianofranz.com)
- experimental policy cli (deads@redhat.com)
- UPSTREAM: need to make sure --help flags is registered before calling pflag
  (contact@fabianofranz.com)
- UPSTREAM: Use new resource builder in kubectl update #3805
  (nagy.martin@gmail.com)
- add missing reencrypt validations (pweil@redhat.com)

* Wed Feb 04 2015 Scott Dodson <sdodson@redhat.com> 0.2.2-0
- Merge tag 'v0.2.2' (sdodson@redhat.com)
- Merge pull request #861 from smarterclayton/version_images
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #851 from bparees/remove_guestbook
  (dmcphers+openshiftbot@redhat.com)
- Expose two new flags on master --images and --latest-images
  (ccoleman@redhat.com)
- Create an openshift/origin-pod image (ccoleman@redhat.com)
- Merge pull request #840 from mfojtik/gofmt (dmcphers+openshiftbot@redhat.com)
- Merge pull request #850 from sg00dwin/refactor-css-and-filter
  (dmcphers+openshiftbot@redhat.com)
- remove guestbook example (bparees@redhat.com)
- Merge pull request #847 from bparees/build_description
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #849 from phemmer/kubernetes_capabilities
  (dmcphers+openshiftbot@redhat.com)
- Refactor css, variablize more values and restructure label filter markup
  (sgoodwin@redhat.com)
- Merge pull request #841 from mfojtik/build_in_docker
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #846 from ironcladlou/deployer-race-fix
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #839 from smarterclayton/add_auth_proxy
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #842 from deads2k/deads-registry-errors
  (dmcphers+openshiftbot@redhat.com)
- better description of output to field (bparees@redhat.com)
- move kubernetes capabilities to server start (patrick.hemmer@gmail.com)
- Add --check option to run golint and gofmt in ./hack/build-in-docker.sh
  (mfojtik@redhat.com)
- Add retry logic to recreate deployment strategy (ironcladlou@gmail.com)
- Very simple authorizing proxy for Kubernetes (ccoleman@redhat.com)
- Unify authorization logic into a more structured form (ccoleman@redhat.com)
- User registry should transform server errors (ccoleman@redhat.com)
- UPSTREAM: Handle case insensitive node names and squash logging
  (ccoleman@redhat.com)
- remove unnecessary rest methods (deads@redhat.com)
- UPSTREAM: add flag to manage $KUBECONFIG files: #4053, bugzilla 1188208
  (deads@redhat.com)
- Add ./hack/build-in-docker.sh script (mfojtik@redhat.com)
- Fix Go version checking in verify-gofmt (mfojtik@redhat.com)
- Merge pull request #833 from csrwng/update_docker_pkgs
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #831 from
  derekwaynecarr/sample_projects_have_different_names
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #808 from sdodson/haproxy-1510
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #837 from liggitt/login (dmcphers+openshiftbot@redhat.com)
- Merge pull request #819 from sosiouxme/201502-sample-app-docs
  (dmcphers+openshiftbot@redhat.com)
- Use $http (jliggitt@redhat.com)
- Merge pull request #789 from fabianofranz/cobra_local_global_flags_separation
  (dmcphers+openshiftbot@redhat.com)
- sample-app docs: update for TLS, namespace, context (lmeyer@redhat.com)
- Merge pull request #801 from jwforres/filter_widget
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #834 from bparees/imagerepo_labels
  (dmcphers+openshiftbot@redhat.com)
- Removed "Additional Help Topics" section from help template
  (contact@fabianofranz.com)
- Use our own templates to cli help and usage (contact@fabianofranz.com)
- UPSTREAM: spf13/cobra help display separate groups of flags
  (contact@fabianofranz.com)
- Merge pull request #825 from smarterclayton/update_kubectl
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #798 from lhuard1A/fix_vagrant_net
  (dmcphers+openshiftbot@redhat.com)
- Label filtering widget in the web console, styles by @sg00dwin
  (jforrest@redhat.com)
- Merge pull request #829 from deads2k/deads-ignore-local-kubeconfig
  (dmcphers+openshiftbot@redhat.com)
- remove unnecessary labels from sample imagerepos (bparees@redhat.com)
- Add shortcuts for build configs and deployment configs (ccoleman@redhat.com)
- Remove kubecfg, expose kubectl in its place (ccoleman@redhat.com)
- bump(github.com/docker/docker):211513156dc1ace48e630b4bf4ea0fcfdc8d9abf
  (cewong@redhat.com)
- Update project display name for sample app (decarr@redhat.com)
- UPSTREAM: typos (contact@fabianofranz.com)
- Merge remote-tracking branch 'origin-upstream/master' (sdodson@redhat.com)
- Merge pull request #812 from liggitt/display_token
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #675 from deads2k/deads-openshift-authorization-impl
  (dmcphers+openshiftbot@redhat.com)
- ignore local .kubeconfig (deads@redhat.com)
- Improve /oauth/token/request page (jliggitt@redhat.com)
- Merge pull request #804 from danmcp/master (dmcphers+openshiftbot@redhat.com)
- Compile haproxy with generic CPU instructions (sdodson@redhat.com)
- Fix multi minion setup (dmcphers@redhat.com)
- policy authorizer (deads@redhat.com)
- policy client (deads@redhat.com)
- policy storage (deads@redhat.com)
- policy types (deads@redhat.com)
- Fix the Vagrant network setup (lhuard@amadeus.com)
- Remove empty log files and use a slightly different process kill method
  (ccoleman@redhat.com)
- Refactor to match upstream master changes (ccoleman@redhat.com)
- Better debug output in deployment_config_controller (ccoleman@redhat.com)
- Adapt to upstream changes for cache.Store (ccoleman@redhat.com)
- UPSTREAM: Relax validation around annotations (ccoleman@redhat.com)
- UPSTREAM: Support GetByKey so EventStore can de-dup (ccoleman@redhat.com)
- UPSTREAM: Add 'release' field to raven-go (ccoleman@redhat.com)
- UPSTREAM: Allow namespace short to be set (ccoleman@redhat.com)
- UPSTREAM: api registration right on mux makes it invisible to container
  (contact@fabianofranz.com)
- UPSTREAM: Disable auto-pull when tag is "latest" (ccoleman@redhat.com)
- UPSTREAM: Disable UIs for Kubernetes and etcd (ccoleman@redhat.com)
- bump(github.com/GoogleCloudPlatform/kubernetes):e335e2d3e26a9a58d3b189ccf41ce
  b3770d1bfa9 (ccoleman@redhat.com)
- Escape helper echo in rebase-kube (ccoleman@redhat.com)
- only kill and remove k8s managed containers (bparees@redhat.com)
- Gofmt whitespace flaw (ccoleman@redhat.com)
- Helper function for rebase output (ccoleman@redhat.com)
- UPSTREAM: Disable UIs for Kubernetes and etcd (ccoleman@redhat.com)
- UPSTREAM: Disable auto-pull when tag is "latest" (ccoleman@redhat.com)
- Merge pull request #816 from smarterclayton/properly_vesrion
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #797 from smarterclayton/wire_up_api_to_node
  (dmcphers+openshiftbot@redhat.com)
- Godeps: update tags to be accurate (ccoleman@redhat.com)
- Properly version Kubernetes and OpenShift binaries (ccoleman@redhat.com)
- Merge pull request #815 from smarterclayton/travis_flake
  (dmcphers+openshiftbot@redhat.com)
- Connect the node to the master via and a built in client
  (ccoleman@redhat.com)
- Rebase fixes (ccoleman@redhat.com)
- Fix flaky travis by limiting parallel builds (ccoleman@redhat.com)
- UPSTREAM: api registration right on mux makes it invisible to container
  (contact@fabianofranz.com)
- UPSTREAM: Allow namespace short to be set (ccoleman@redhat.com)
- bump(github.com/GoogleCloudPlatform/kubernetes):e0acd75629ec29bde764bcde29367
  146ae8b389b (jhonce@redhat.com)
- Merge pull request #811 from smarterclayton/pkill_must_be_sudo
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #786 from ironcladlou/rollback-cli
  (dmcphers+openshiftbot@redhat.com)
- pkill on test-end-to-end.sh must be sudo (ccoleman@redhat.com)
- Merge pull request #810 from liggitt/oauth_token_user_uid
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #809 from liggitt/relative_kubeconfig
  (dmcphers+openshiftbot@redhat.com)
- Set user UID in session (jliggitt@redhat.com)
- Implement deployment rollback CLI support (ironcladlou@gmail.com)
- Merge pull request #792 from liggitt/oauth_prefix
  (dmcphers+openshiftbot@redhat.com)
- Merge pull request #807 from danmcp/allow_root
  (dmcphers+openshiftbot@redhat.com)
- Make file references relative in generated .kubeconfig files
  (jliggitt@redhat.com)
- Add ability to retrieve userIdentityMapping (jliggitt@redhat.com)
- Add "Oauth" prefix to oauth types (jliggitt@redhat.com)
- Register internal OAuth API objects correctly (jliggitt@redhat.com)
- Merge pull request #788 from sosiouxme/201501-vagrant-providers
  (dmcphers+openshiftbot@redhat.com)
- Allow bower to run as root (dmcphers@redhat.com)
- Vagrantfile: improve providers and usability/readability (lmeyer@redhat.com)
- UPSTREAM: resolve relative paths in .kubeconfig (deads@redhat.com)
- Pin haproxy to 1.5.10 (sdodson@redhat.com)
- Fix the Vagrant network setup (lhuard@amadeus.com)

* Fri Jan 30 2015 Scott Dodson <sdodson@redhat.com> 0.2.1-4
- new package built with tito

* Mon Jan 26 2015 Scott Dodson <sdodson@redhat.com> 0.2-3
- Update to 21fb40637c4e3507cca1fcab6c4d56b06950a149
- Split packaging of openshift-master and openshift-node

* Mon Jan 19 2015 Scott Dodson <sdodson@redhat.com> 0.2-2
- new package built with tito

* Fri Jan 09 2015 Adam Miller <admiller@redhat.com> - 0.2-2
- Add symlink for osc command line tooling (merged in from jhonce@redhat.com)

* Wed Jan 07 2015 Adam Miller <admiller@redhat.com> - 0.2-1
- Update to latest upstream release
- Restructured some of the golang deps  build setup for restructuring done
  upstream

* Thu Oct 23 2014 Adam Miller <admiller@redhat.com> - 0-0.0.9.git562842e
- Add new patches from jhonce for systemd units

* Mon Oct 20 2014 Adam Miller <admiller@redhat.com> - 0-0.0.8.git562842e
- Update to latest master snapshot

* Wed Oct 15 2014 Adam Miller <admiller@redhat.com> - 0-0.0.7.git7872f0f
- Update to latest master snapshot

* Fri Oct 03 2014 Adam Miller <admiller@redhat.com> - 0-0.0.6.gite4d4ecf
- Update to latest Alpha nightly build tag 20141003

* Wed Oct 01 2014 Adam Miller <admiller@redhat.com> - 0-0.0.5.git6d9f1a9
- Switch to consistent naming, patch by jhonce

* Tue Sep 30 2014 Adam Miller <admiller@redhat.com> - 0-0.0.4.git6d9f1a9
- Add systemd and sysconfig entries from jhonce

* Tue Sep 23 2014 Adam Miller <admiller@redhat.com> - 0-0.0.3.git6d9f1a9
- Update to latest upstream.

* Mon Sep 15 2014 Adam Miller <admiller@redhat.com> - 0-0.0.2.git2647df5
- Update to latest upstream.

* Thu Aug 14 2014 Adam Miller <admiller@redhat.com> - 0-0.0.1.gitc3839b8
- First package

